/*
 * Copyright 2016-2020 Cloudera, Inc.
 * <p>
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * <p>
 * http://www.apache.org/licenses/LICENSE-2.0
 * <p>
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.hortonworks.registries.schemaregistry.state;

/**
 * This class defines what needs to be executed on transition from one state to other state.
 */
public interface SchemaVersionLifecycleStateAction {

    /**
     * @param context which gives the context about the state machine and any dependent services.
     *
     * @throws SchemaLifecycleException any Exceptions occur will be wrapper in this and consumers of this API
     *                                  should check for root cause and take appropriate action.
     */
    void execute(SchemaVersionLifecycleContext context) throws SchemaLifecycleException;
}
